<template lang='pug'>
mixin prop(name)
  li #[strong.text-info= name+': ']
    block

Example(title='BaseKeyboardEventMixin (Mixin)' :maxState='0')
  template(v-slot:description)
    h5 This mixin will make your components able to handle local or global keyboard events
    p Click on #[em interface] to view the full specifications.
    hr
    p The event key syntax is: #[code "{metaKeys}-{key}-{keyup|keydown}"] where
    ul
      +prop("metaKeys")
        | ctrl, shift, meta, alt, ctrl-shift, alt-shift, etc...
      +prop("key")
        | a, e, w etc... (could be also a metaKey)
      +prop("keyup|keydown")
        | It's optional and by default is #[code keyup] if you do not provide it.
    br
    p Let's play with this tool! This mixin is integrated in this BaseCard Example.
      |
      | Use the following input to register or remove key events. When the key event will fire
      | you should see an event being registered in the event area.
    .row.justify-content-center.align-items-center.b-param-container
      // ParamInput.col-6(v-model='keyInput' :inEdit='true' title='Key')
      BaseInput(type='text' placeholder='type a key combination...' v-model='keyInput' :noEditIcon='true' :inEdit='true')
      button.col-2.mr-1.btn.btn-sm.btn-primary(@click='registerKeyEvent()') Register
      button.col-2.mr-1.btn.btn-sm.btn-primary(@click='removeKeyEvent()') Remove
      button.col-2.mr-1.btn.btn-sm.btn-secondary(@click='eventMessages = []') Clean
      BaseToggle.col-12.text-center(v-model='checkOnInputs' @edit="setInputCheck()" label="Disable Check on Input" :inEdit='true')
    hr
    .row.b-param-container
      p(v-if="eventMessages.length === 0") Still no events!
      div(v-for="message in eventMessages.slice().reverse()" style="width: 100%; font-size: 80%;")
        code {{ message }}
    hr

  template(v-slot:interface)
    h5 BaseKeyboardEventMixin
    p You need to add #[code BaseKeyboardEventMixin] to your component #[code mixins].
    p This mixin accept an option object as parameter:
    p #[code { local: false,  checkOnInputs: true} ]
    p where:
    ul
      +prop("local: boolean (default: false)")
        | Register the Keyboard handler at global or at component level.
      +prop("checkOnInputs: boolean (default: true)")
        | If true it will prevents registered callbacks to be executed
        |
        | if the focus is on an input field (including also select and textarea).
    br
    p This mixin adds the following API to the component:
    ul
      +prop("onKey(key: string, callback: function): void")
        | Register a key event #[code key] and trigger #[code callback] when occurs.
      +prop("onKeyEmit(key: string, signal?: string): void")
        | Register a key event #[code key] end emit #[code signal] when occurs.
        |
        | If #[code signal] is not provided, a signal named #[code key] will be emitted.
      +prop("removeKey(key: string, callback?: function)")
        | Remove a key event #[code key] with a specific #[code callback].
        |
        | If #[code callback] is not provided, all key events with #[code key] will be removed.
      +prop("setCheckOnInput(value: boolean)")
        | Sets if the check of the focus on an input field must prevent to fire the callback.

      +prop('showKeyHints: boolean')
        | Computed property displaying ui store showKeyHints state
    br
    p Some important properties and behavior:
    ul
      li Disabling the check on Inputs could make the user experience difficult while typing in forms.
      li Registered callbacks will be removed automatically when the component is destroyed.
      li Nothing prevents to other DOM components to listen on the same event and to
        |
        | call #[code stopPropagation()]. This will stop the event propagation and it could never
        |
        | reach the event handler of this component.
      li If the keyboard event reach this component and the focus is on an input element,
        |
        | the callback registered will be executed only if the key event was triggered with
        |
        | a modifiers (shift, ctrl, alt or meta). The only exclusion is when "esc" key is pressed.
      li It is possible to register multiple event for the same key (but with different callback).
        |
        | In this way it creates a chain of callbacks that are going to be triggered
        |
        | in sequence as they are registered. If one of the callback in the chain return false,
        |
        | it will stop the execution of the remaining callbacks.
      li Do not use shortcuts that are used by the system or that the browser does not pass
        |
        | to the web page like ctrl-w, ctrl-shift-w, ctrl-t, ctrl-shift-t, alt-f4 etc... .
        |
        | If you really need to use them, be sure to correctly use #[code keydown] or #[code keyup]
        |
        | and to call #[code event.preventDefault()] and/or #[code event.stopPropagation()] based
        |
        | on what you want to achieve.
</template>
<script>
import { BaseKeyboardEventMixin } from "../src";
import Example from "./AppExample.vue";
import _ from "lodash";

export default {
  name: "ExampleKeyboardEventMixin",
  components: { Example },
  mixins: [ BaseKeyboardEventMixin({ local: false }) ],
  data: () => {
    return {
      eventMessages: [],
      keyInput: "",
      checkOnInputs: true
    };
  },
  mounted() {
    _.bindAll(this, [ "eventCallback" ]);
  },
  methods: {
    registerKeyEvent() {
      // Do a base check of the input?
      if (_.isEmpty(this.keyInput)) { return; }
      this.onKey(this.keyInput, this.eventCallback);
      this.eventMessages.push(`Key Event [ ${this.keyInput} ] registered.`);
    },
    removeKeyEvent() {
      this.removeKey(this.keyInput, this.eventCallback);
      this.eventMessages.push(`Key Event [ ${this.keyInput} ] removed.`);
    },
    eventCallback(event) {
      const mods = [];
      if (event.ctrlKey) { mods.push("ctrl"); }
      if (event.altKey) { mods.push("alt"); }
      if (event.shiftKey) { mods.push("shift"); }
      if (event.metaKey) { mods.push("meta"); }
      const isInput = event.target.tagName === "INPUT" ||
                      event.target.tagName === "SELECT" ||
                      event.target.tagName === "TEXTAREA" ||
                      event.target.isContentEditable;
      this.eventMessages.push(
        `Event received. Mods [ ${mods.join("-")} ] Key [ ${event.key} ] FocusOnInput [ ${isInput} ]`);
    },
    setInputCheck() {
      this.setCheckOnInput(this.checkOnInputs);
    }
  }
};
</script>
